Index: uspace/drv/uhci-hcd/iface.c
===================================================================
--- uspace/drv/uhci-hcd/iface.c	(revision 1c6a45f787bcff8490498e6a9e7b6db8600e85b4)
+++ uspace/drv/uhci-hcd/iface.c	(revision 87644b475e40058a32e8bf51a05dc7c729e2321d)
@@ -78,6 +78,6 @@
  * @return Error code.
  */
-static int request_address(ddf_fun_t *fun, usb_speed_t speed,
-    usb_address_t *address)
+static int request_address(
+    ddf_fun_t *fun, usb_speed_t speed, usb_address_t *address)
 {
 	assert(fun);
@@ -139,19 +139,20 @@
  * @return Error code.
  */
-static int interrupt_out(ddf_fun_t *fun, usb_target_t target,
-    size_t max_packet_size, void *data, size_t size,
-    usbhc_iface_transfer_out_callback_t callback, void *arg)
-{
-	assert(fun);
-	hc_t *hc = fun_to_hc(fun);
-	assert(hc);
-	usb_speed_t speed = usb_device_keeper_get_speed(&hc->manager, target.address);
+static int interrupt_out(
+    ddf_fun_t *fun, usb_target_t target, size_t max_packet_size, void *data,
+    size_t size, usbhc_iface_transfer_out_callback_t callback, void *arg)
+{
+	assert(fun);
+	hc_t *hc = fun_to_hc(fun);
+	assert(hc);
+	usb_speed_t speed =
+	    usb_device_keeper_get_speed(&hc->manager, target.address);
 
 	usb_log_debug("Interrupt OUT %d:%d %zu(%zu).\n",
 	    target.address, target.endpoint, size, max_packet_size);
 
-	usb_transfer_batch_t *batch = batch_get(fun, target, USB_TRANSFER_INTERRUPT,
-	    max_packet_size, speed, data, size, NULL, 0, NULL, callback, arg,
-	    &hc->manager);
+	usb_transfer_batch_t *batch =
+	    batch_get(fun, target, USB_TRANSFER_INTERRUPT, max_packet_size,
+	        speed, data, size, NULL, 0, NULL, callback, arg, &hc->manager);
 	if (!batch)
 		return ENOMEM;
@@ -160,7 +161,6 @@
 	if (ret != EOK) {
 		batch_dispose(batch);
-		return ret;
-	}
-	return EOK;
+	}
+	return ret;
 }
 /*----------------------------------------------------------------------------*/
@@ -176,18 +176,19 @@
  * @return Error code.
  */
-static int interrupt_in(ddf_fun_t *fun, usb_target_t target,
-    size_t max_packet_size, void *data, size_t size,
-    usbhc_iface_transfer_in_callback_t callback, void *arg)
-{
-	assert(fun);
-	hc_t *hc = fun_to_hc(fun);
-	assert(hc);
-	usb_speed_t speed = usb_device_keeper_get_speed(&hc->manager, target.address);
+static int interrupt_in(
+    ddf_fun_t *fun, usb_target_t target, size_t max_packet_size, void *data,
+    size_t size, usbhc_iface_transfer_in_callback_t callback, void *arg)
+{
+	assert(fun);
+	hc_t *hc = fun_to_hc(fun);
+	assert(hc);
+	usb_speed_t speed =
+	    usb_device_keeper_get_speed(&hc->manager, target.address);
 	usb_log_debug("Interrupt IN %d:%d %zu(%zu).\n",
 	    target.address, target.endpoint, size, max_packet_size);
 
-	usb_transfer_batch_t *batch = batch_get(fun, target, USB_TRANSFER_INTERRUPT,
-	    max_packet_size, speed, data, size, NULL, 0, callback, NULL, arg,
-	    &hc->manager);
+	usb_transfer_batch_t *batch =
+	    batch_get(fun, target, USB_TRANSFER_INTERRUPT, max_packet_size,
+	        speed, data, size, NULL, 0, callback, NULL, arg, &hc->manager);
 	if (!batch)
 		return ENOMEM;
@@ -196,7 +197,6 @@
 	if (ret != EOK) {
 		batch_dispose(batch);
-		return ret;
-	}
-	return EOK;
+	}
+	return ret;
 }
 /*----------------------------------------------------------------------------*/
@@ -212,19 +212,20 @@
  * @return Error code.
  */
-static int bulk_out(ddf_fun_t *fun, usb_target_t target,
-    size_t max_packet_size, void *data, size_t size,
-    usbhc_iface_transfer_out_callback_t callback, void *arg)
-{
-	assert(fun);
-	hc_t *hc = fun_to_hc(fun);
-	assert(hc);
-	usb_speed_t speed = usb_device_keeper_get_speed(&hc->manager, target.address);
+static int bulk_out(
+    ddf_fun_t *fun, usb_target_t target, size_t max_packet_size, void *data,
+    size_t size, usbhc_iface_transfer_out_callback_t callback, void *arg)
+{
+	assert(fun);
+	hc_t *hc = fun_to_hc(fun);
+	assert(hc);
+	usb_speed_t speed =
+	    usb_device_keeper_get_speed(&hc->manager, target.address);
 
 	usb_log_debug("Bulk OUT %d:%d %zu(%zu).\n",
 	    target.address, target.endpoint, size, max_packet_size);
 
-	usb_transfer_batch_t *batch = batch_get(fun, target, USB_TRANSFER_BULK,
-	    max_packet_size, speed, data, size, NULL, 0, NULL, callback, arg,
-	    &hc->manager);
+	usb_transfer_batch_t *batch =
+	    batch_get(fun, target, USB_TRANSFER_BULK, max_packet_size, speed,
+	        data, size, NULL, 0, NULL, callback, arg, &hc->manager);
 	if (!batch)
 		return ENOMEM;
@@ -233,7 +234,6 @@
 	if (ret != EOK) {
 		batch_dispose(batch);
-		return ret;
-	}
-	return EOK;
+	}
+	return ret;
 }
 /*----------------------------------------------------------------------------*/
@@ -249,18 +249,19 @@
  * @return Error code.
  */
-static int bulk_in(ddf_fun_t *fun, usb_target_t target,
-    size_t max_packet_size, void *data, size_t size,
-    usbhc_iface_transfer_in_callback_t callback, void *arg)
-{
-	assert(fun);
-	hc_t *hc = fun_to_hc(fun);
-	assert(hc);
-	usb_speed_t speed = usb_device_keeper_get_speed(&hc->manager, target.address);
+static int bulk_in(
+    ddf_fun_t *fun, usb_target_t target, size_t max_packet_size, void *data,
+    size_t size, usbhc_iface_transfer_in_callback_t callback, void *arg)
+{
+	assert(fun);
+	hc_t *hc = fun_to_hc(fun);
+	assert(hc);
+	usb_speed_t speed =
+	    usb_device_keeper_get_speed(&hc->manager, target.address);
 	usb_log_debug("Bulk IN %d:%d %zu(%zu).\n",
 	    target.address, target.endpoint, size, max_packet_size);
 
-	usb_transfer_batch_t *batch = batch_get(fun, target, USB_TRANSFER_BULK,
-	    max_packet_size, speed, data, size, NULL, 0, callback, NULL, arg,
-	    &hc->manager);
+	usb_transfer_batch_t *batch =
+	    batch_get(fun, target, USB_TRANSFER_BULK, max_packet_size, speed,
+	        data, size, NULL, 0, callback, NULL, arg, &hc->manager);
 	if (!batch)
 		return ENOMEM;
@@ -269,7 +270,6 @@
 	if (ret != EOK) {
 		batch_dispose(batch);
-		return ret;
-	}
-	return EOK;
+	}
+	return ret;
 }
 /*----------------------------------------------------------------------------*/
@@ -287,6 +287,6 @@
  * @return Error code.
  */
-static int control_write(ddf_fun_t *fun, usb_target_t target,
-    size_t max_packet_size,
+static int control_write(
+    ddf_fun_t *fun, usb_target_t target, size_t max_packet_size,
     void *setup_data, size_t setup_size, void *data, size_t size,
     usbhc_iface_transfer_out_callback_t callback, void *arg)
@@ -295,5 +295,6 @@
 	hc_t *hc = fun_to_hc(fun);
 	assert(hc);
-	usb_speed_t speed = usb_device_keeper_get_speed(&hc->manager, target.address);
+	usb_speed_t speed =
+	    usb_device_keeper_get_speed(&hc->manager, target.address);
 	usb_log_debug("Control WRITE (%d) %d:%d %zu(%zu).\n",
 	    speed, target.address, target.endpoint, size, max_packet_size);
@@ -302,7 +303,8 @@
 		return EINVAL;
 
-	usb_transfer_batch_t *batch = batch_get(fun, target, USB_TRANSFER_CONTROL,
-	    max_packet_size, speed, data, size, setup_data, setup_size,
-	    NULL, callback, arg, &hc->manager);
+	usb_transfer_batch_t *batch =
+	    batch_get(fun, target, USB_TRANSFER_CONTROL, max_packet_size, speed,
+	        data, size, setup_data, setup_size, NULL, callback, arg,
+	        &hc->manager);
 	if (!batch)
 		return ENOMEM;
@@ -312,7 +314,6 @@
 	if (ret != EOK) {
 		batch_dispose(batch);
-		return ret;
-	}
-	return EOK;
+	}
+	return ret;
 }
 /*----------------------------------------------------------------------------*/
@@ -330,6 +331,6 @@
  * @return Error code.
  */
-static int control_read(ddf_fun_t *fun, usb_target_t target,
-    size_t max_packet_size,
+static int control_read(
+    ddf_fun_t *fun, usb_target_t target, size_t max_packet_size,
     void *setup_data, size_t setup_size, void *data, size_t size,
     usbhc_iface_transfer_in_callback_t callback, void *arg)
@@ -338,11 +339,13 @@
 	hc_t *hc = fun_to_hc(fun);
 	assert(hc);
-	usb_speed_t speed = usb_device_keeper_get_speed(&hc->manager, target.address);
+	usb_speed_t speed =
+	    usb_device_keeper_get_speed(&hc->manager, target.address);
 
 	usb_log_debug("Control READ(%d) %d:%d %zu(%zu).\n",
 	    speed, target.address, target.endpoint, size, max_packet_size);
-	usb_transfer_batch_t *batch = batch_get(fun, target, USB_TRANSFER_CONTROL,
-	    max_packet_size, speed, data, size, setup_data, setup_size, callback,
-	    NULL, arg, &hc->manager);
+	usb_transfer_batch_t *batch =
+	    batch_get(fun, target, USB_TRANSFER_CONTROL, max_packet_size, speed,
+	        data, size, setup_data, setup_size, callback, NULL, arg,
+		&hc->manager);
 	if (!batch)
 		return ENOMEM;
@@ -351,7 +354,6 @@
 	if (ret != EOK) {
 		batch_dispose(batch);
-		return ret;
-	}
-	return EOK;
+	}
+	return ret;
 }
 /*----------------------------------------------------------------------------*/