Index: kernel/genarch/src/drivers/i8042/i8042.c
===================================================================
--- kernel/genarch/src/drivers/i8042/i8042.c	(revision e0b0c257732262412575238a5815d8deebc8aa6d)
+++ kernel/genarch/src/drivers/i8042/i8042.c	(revision 137691a0a5feba69b6234f718e44f11b08988387)
@@ -67,7 +67,6 @@
 	i8042_instance_t *instance = irq->instance;
 	i8042_t *dev = instance->i8042;
-	uint8_t status;
 	
-	if (((status = pio_read_8(&dev->status)) & i8042_BUFFER_FULL_MASK)) {
+	if (pio_read_8(&dev->status) & i8042_BUFFER_FULL_MASK) {
 		uint8_t data = pio_read_8(&dev->data);
 		indev_push_character(instance->kbrdin, data);
Index: kernel/generic/include/bitops.h
===================================================================
--- kernel/generic/include/bitops.h	(revision e0b0c257732262412575238a5815d8deebc8aa6d)
+++ kernel/generic/include/bitops.h	(revision 137691a0a5feba69b6234f718e44f11b08988387)
@@ -65,8 +65,6 @@
 	}
 	
-	if (arg >> 1) {
-		arg >>= 1;
+	if (arg >> 1)
 		n += 1;
-	}
 	
 	return n;
Index: kernel/generic/src/console/kconsole.c
===================================================================
--- kernel/generic/src/console/kconsole.c	(revision e0b0c257732262412575238a5815d8deebc8aa6d)
+++ kernel/generic/src/console/kconsole.c	(revision 137691a0a5feba69b6234f718e44f11b08988387)
@@ -224,5 +224,5 @@
 		printf("\n");
 		pos = NULL;
-		while ((hint = cmdtab_search_one(name, &pos))) {
+		while (cmdtab_search_one(name, &pos)) {
 			cmd_info_t *hlp = list_get_instance(pos, cmd_info_t, link);
 			printf("%s (%s)\n", hlp->name, hlp->description);
Index: kernel/generic/src/debug/symtab.c
===================================================================
--- kernel/generic/src/debug/symtab.c	(revision e0b0c257732262412575238a5815d8deebc8aa6d)
+++ kernel/generic/src/debug/symtab.c	(revision 137691a0a5feba69b6234f718e44f11b08988387)
@@ -239,5 +239,5 @@
 		printf("\n");
 		pos = 0;
-		while ((hint = symtab_search_one(name, &pos))) {
+		while (symtab_search_one(name, &pos)) {
 			printf("%s\n", symbol_table[pos].symbol_name);
 			pos++;
Index: kernel/generic/src/lib/elf.c
===================================================================
--- kernel/generic/src/lib/elf.c	(revision e0b0c257732262412575238a5815d8deebc8aa6d)
+++ kernel/generic/src/lib/elf.c	(revision 137691a0a5feba69b6234f718e44f11b08988387)
@@ -155,6 +155,4 @@
     as_t *as, int flags)
 {
-	char *interp;
-
 	switch (entry->p_type) {
 	case PT_NULL:
@@ -165,10 +163,11 @@
 	case PT_DYNAMIC:
 	case PT_INTERP:
-		interp = (char *)elf + entry->p_offset;
-		/* FIXME */
-		/*if (memcmp((uintptr_t)interp, (uintptr_t)ELF_INTERP_ZSTR,
+		// FIXME
+		/*
+		char *interp = (char *) elf + entry->p_offset;
+		if (memcmp((uintptr_t) interp, (uintptr_t) ELF_INTERP_ZSTR,
 		    ELF_INTERP_ZLEN) != 0) {
 			return EE_UNSUPPORTED;
-		}*/
+		} */
 		if ((flags & ELD_F_LOADER) == 0) {
 			return EE_LOADER;
Index: kernel/generic/src/mm/as.c
===================================================================
--- kernel/generic/src/mm/as.c	(revision e0b0c257732262412575238a5815d8deebc8aa6d)
+++ kernel/generic/src/mm/as.c	(revision 137691a0a5feba69b6234f718e44f11b08988387)
@@ -784,5 +784,4 @@
 {
 	as_area_t *area;
-	uintptr_t base;
 	link_t *cur;
 	ipl_t ipl;
@@ -813,6 +812,4 @@
 		return ENOTSUP;
 	}
-
-	base = area->base;
 
 	/*
Index: kernel/generic/src/mm/backend_elf.c
===================================================================
--- kernel/generic/src/mm/backend_elf.c	(revision e0b0c257732262412575238a5815d8deebc8aa6d)
+++ kernel/generic/src/mm/backend_elf.c	(revision 137691a0a5feba69b6234f718e44f11b08988387)
@@ -232,14 +232,9 @@
 void elf_frame_free(as_area_t *area, uintptr_t page, uintptr_t frame)
 {
-	elf_header_t *elf = area->backend_data.elf;
 	elf_segment_header_t *entry = area->backend_data.segment;
-	uintptr_t base, start_anon;
-	size_t i;
+	uintptr_t start_anon;
 
 	ASSERT((page >= ALIGN_DOWN(entry->p_vaddr, PAGE_SIZE)) &&
 	    (page < entry->p_vaddr + entry->p_memsz));
-	i = (page - ALIGN_DOWN(entry->p_vaddr, PAGE_SIZE)) >> PAGE_WIDTH;
-	base = (uintptr_t) (((void *) elf) +
-	    ALIGN_DOWN(entry->p_offset, FRAME_SIZE));
 	start_anon = entry->p_vaddr + entry->p_filesz;
 
@@ -257,5 +252,5 @@
 		 * lower part is backed by the ELF image and the upper is
 		 * anonymous). In any case, a frame needs to be freed.
-		 */ 
+		 */
 		frame_free(frame);
 	}
Index: kernel/generic/src/proc/thread.c
===================================================================
--- kernel/generic/src/proc/thread.c	(revision e0b0c257732262412575238a5815d8deebc8aa6d)
+++ kernel/generic/src/proc/thread.c	(revision 137691a0a5feba69b6234f718e44f11b08988387)
@@ -264,4 +264,5 @@
 
 	atomic_inc(&nrdy);
+	// FIXME: Why is the avg value never read?
 	avg = atomic_get(&nrdy) / config.cpu_active;
 	atomic_inc(&cpu->nrdy);
Index: kernel/generic/src/sysinfo/sysinfo.c
===================================================================
--- kernel/generic/src/sysinfo/sysinfo.c	(revision e0b0c257732262412575238a5815d8deebc8aa6d)
+++ kernel/generic/src/sysinfo/sysinfo.c	(revision 137691a0a5feba69b6234f718e44f11b08988387)
@@ -46,5 +46,5 @@
 		return NULL;
 	
-	while (subtree != NULL)	{
+	while (subtree != NULL) {
 		int i = 0;
 		char *a = (char *) name;
@@ -68,5 +68,4 @@
 		/* No matches try next */
 		subtree = subtree->next;
-		i = 0;
 	}
 	return NULL;
@@ -159,8 +158,6 @@
 			item->subinfo_type = SYSINFO_SUBINFO_NONE;
 			return item;
-		} else {
+		} else
 			subtree = subtree->next;
-			i = 0;
-		}	
 	}
 
Index: kernel/generic/src/udebug/udebug_ops.c
===================================================================
--- kernel/generic/src/udebug/udebug_ops.c	(revision e0b0c257732262412575238a5815d8deebc8aa6d)
+++ kernel/generic/src/udebug/udebug_ops.c	(revision 137691a0a5feba69b6234f718e44f11b08988387)
@@ -80,8 +80,5 @@
 static int _thread_op_begin(thread_t *t, bool being_go)
 {
-	task_id_t taskid;
 	ipl_t ipl;
-
-	taskid = TASK->taskid;
 
 	mutex_lock(&TASK->udebug.lock);